﻿; wakiewakie v1.44 - ejn (blueznl)
; pb3.62 x86
; wol and ping tool for (wireless) htpc setups
;
#ww_version = "v1.44"
#ww_copyright = "c2013..2019 EJN"
;
EnableExplicit
IncludeFile "..\x_lib\x_lib.pb"
Declare init()
Declare main()
;
InitNetwork()
x_init()
init()
main()
x_end()
End

Procedure wakiewakie_history()
  ;
  ; current
  ;
  ; v1.44
  ;
  ; - added 'all' parameter for wifi setups
  ;
  ; v1.41
  ;
  ; - some more tweaking of adaptive linger mode
  ; - adaptive lingering maximized to 3 minutes
  ; - default retry 500
  ;
  ; v1.39
  ;
  ; - updated documentation
  ; - added some extra time to adaptive lingering
  ;
  ; v1.37
  ;
  ; - modified linger logic, see help file, added linger progress indicator
  ; - default linger 700
  ;
  ; v1.36
  ;
  ; - changed something (forgot what...)
  ;
  ; v1.35
  ;
  ; - added alias 'window' for 'border'
  ; - changed border parameters, 0 = invisible now!
  ; - default retry 400 linger 1500
  ; - adaptive lingering, linger doubles on cold boots
  ; - default now done by a constant, easier to update :-)
  ;
  ; v1.29
  ;
  ; - added color <front> <back> (only when not using gui)
  ; - added black option
  ; - added border <size> option
  ; - default retry 400
  ; - default linger 400
  ; - added optional parameter field 'other'
  ; - little faster
  ; - resolving name and mac no longer interfere
  ;
  ; v1.28x
  ;
  ; - no need to linger on hot boot
  ;
  ; v1.27x
  ;
  ; - added history option (creates a data file in the wakiewakie directory)
  ; - added clear (history) option
  ; - added linger option, default 400
  ; - added status led for history mode
  ; - some default (empiric) values to start history calculations
  ; - last state is stored in history file
  ;
  ; v1.18
  ;
  ; - improved documentation
  ;
  ; v1.17x
  ;
  ; - speed up, do not resolve network names of server and router on first pass outside gui
  ;
  ; v1.16x
  ;
  ; - could sometimes report wrong number of ip adapters, hopefully fixed
  ;
  ; v1.15x
  ;
  ; - tested with pb 3.50... no problems found
  ;
  ; v1.13x
  ;
  ; - resolving mac and ip could sometimes take too much time (mostly on windows xp boxes), fixed
  ; - resolved mac and name for server or router now only update if the specified ip changed, pings are still 'live'
  ; - increased ping timeout to 100 msec as some routers are very slow to respond on subsequent pings
  ;
  ; v1.11x
  ;
  ; - added a led to indicate there's an autorun entry
  ; - added a button to copy mac address from a succesfull server ping
  ;
  ; v1.08x
  ;
  ; - now includes more led colours
  ; - create shortcut on the desktop with parameters for easier use
  ;
  ; v1.06x
  ;
  ; - forgot to include the icons in the binary, oops
  ;
  ; v1.05x
  ;
  ; - alert when passing unrecognized parameter
  ; - fail on ping server now triggers another wol
  ; - minor tweak prgressbar
  ; - updated documentation
  ;
  ; v1.03x
  ;
  ; - full rework of internal logic
  ;
  ; v1.02x
  ;
  ; - bugfix (sometimes retrieved mac adresses even when server was not pingable)
  ;
  ; v1.01x
  ;
  ; - fugured out WOL and ping
  ; - not the prettiest code, but it seems to work :-)
  ; - first release!
  ;
EndProcedure

Procedure init()
  ;
  ; *** gui elements
  ;
  Enumeration
    ;
    #w_main_nr
    #g_adapter_led
    #g_adapter_t
    #g_adapter_ip
    #g_adapter_note
    #g_router_led
    #g_router_t
    #g_router_ip
    #g_router_note
    #g_server_ip_led
    #g_server_ip_t
    #g_server_ip
    #g_server_ip_take
    #g_server_mac_t
    #g_server_mac
    #g_server_note
    #g_retry_t
    #g_retry_time
    #g_retry_note
    #g_commandline_t
    #g_commandline
    #g_commandline_other_t
    #g_commandline_other
    ;
    #g_progress_bar
    #g_progress_led
    #g_autorun_led
    #g_autorun_set
    #g_autorun_clear
    #g_copy
    #g_help
    #g_exit
    #g_shortcut
    ;
  EndEnumeration
  ;
  Global w_main_h.i
  ;
  ; *** images
  ;
  Enumeration
    ;
    #i_led_red
    #i_led_green
    #i_led_white
    #i_led_yellow
    #i_led_cyan
    #i_windows
    #i_windows_grey
    #i_copy
    #i_help
    #i_exit
    #i_shortcut
    ;
  EndEnumeration
  ;
  DataSection
    ;
    i_led_red:
    IncludeBinary("icons\led_red.ico")
    i_led_green:
    IncludeBinary("icons\led_green.ico")
    i_led_white:
    IncludeBinary("icons\led_white.ico")
    i_led_yellow:
    IncludeBinary("icons\led_yellow.ico")
    i_led_cyan:
    IncludeBinary("icons\led_cyan.ico")
    i_copy:
    IncludeBinary("icons\copy.ico")
    i_help:
    IncludeBinary("icons\help.ico")
    i_exit:
    IncludeBinary("icons\exit.ico")
    i_shortcut:
    IncludeBinary("icons\shortcut.ico")
    i_windows_xp:
    IncludeBinary("icons\windows_xp.ico")
    i_windows_grey:
    IncludeBinary("icons\windows_grey.ico")
    ;
  EndDataSection
  ;
  Global i_led_red_h       = CatchImage(#i_led_red,      ?i_led_red)
  Global i_led_green_h     = CatchImage(#i_led_green,    ?i_led_green)
  Global i_led_white_h     = CatchImage(#i_led_white,    ?i_led_white)
  Global i_led_yelow_h     = CatchImage(#i_led_yellow,   ?i_led_yellow)
  Global i_led_cyan_h      = CatchImage(#i_led_cyan,     ?i_led_cyan)
  Global i_copy_h          = CatchImage(#i_copy,         ?i_copy)
  Global i_help_h          = CatchImage(#i_help,         ?i_help)
  Global i_exit_h          = CatchImage(#i_exit,         ?i_exit)
  Global i_shortcut_h      = CatchImage(#i_shortcut,     ?i_shortcut)
  Global i_windows_h       = CatchImage(#i_windows,      ?i_windows_xp)
  Global i_windows_grey_h  = CatchImage(#i_windows_grey, ?i_windows_grey)
  ;
  ; *** actions
  ;
  Enumeration
    ;
    #f_none
    #f_check_adapter
    #f_ping_router
    #f_wakeup_server
    #f_ping_server
    #f_done
    #f_exit
    ;
  EndEnumeration
  ;
  ; *** event handling
  ;
  Global action.i
  Global event.i
  Global event_window.i
  Global event_menu.i
  Global event_type.i
  Global event_gadget.i
  ;
  ; *** application specific
  ;
  Global adapter_ip.s             ; patten to check local host adapter, for example 192.168.*.*
  Global adapter_note.s           ; additional information on local host adapter(s)
  Global router_ip.s              ; device to ping, for example 192.168.1.99
  Global router_mac_resolved.s    ; router mac resolved for specific ip
  Global router_name_resolved.s   ; router name resolved for specific ip
  Global server_ip.s              ; address of server, for example 192.168.1.91
  Global server_mac_resolved.s    ; mac address found when ping server succeeded
  Global server_name_resolved.s   ; name found for specified server ip
  Global server_mac.s             ; manually entered mac address
  Global commandline_other.s      ; additional manual command line parameters
  Global commandline.s            ; detected or generated command line
  Global history_filename.s       ; filename used to store history
  Global history_n.i              ; number of entries in history file
  Global timestamp.s              ; timestap of attempt
  Global starttime.i              ; start time current attemt (in msec)
  Global attempts.i      = 0      ; number of attempts
  Global warm.i          = 10000  ; average 'warm' startup time (from standby)
  Global average.i       = 25000  ; average succesful startup time (excluding hot)
  Global cold.i          = 40000  ; average 'cold' startup time (from boot)
  Global gui.i           = #False ; use gui yes / no
  Global slow.i          = #False ; slow mode
  Global history.i       = #False ; store previous wake up times to predict this one
  Global history_clear.i = #False ; flag to ignore history data (effectively clearing it)
  Global color_front     = -1     ; default front color use system, not used in gui
  Global color_back      = -1     ; default back color use system, not used in gui
  Global border.i        = -1     ; -1 system (default) 0 no border 1 tool window
  Global all.i           = #False ; when set to 1 all checks must pass before continueing
  ;
  #retry_time            = 500    ; time before next check / loop
  #linger_time           = -1000  ; continue immediately when 'hot', otherwise linger for specified number of msecs
  Global retry_time.i    = #retry_time
  Global linger_time.i   = #linger_time
  ;
  ; history related
  ;
  Structure history
    timestamp.s                 ; timestamp of last attempt for specific entry
    name.s                      ; previously resolved name
    ip.s                        ; ip address
    mac.s                       ; max address
    attempts.i                  ; number of attempts
    average.i                   ; average wait time
    cold.i                      ; average wait time of all 'cold' boots (from power down)
    warm.i                      ; average 'warm' startup time (from standby)
    state.s                     ; last state (fail, cold cold, cold, warm, warm warm, hot)
  EndStructure
  ;
  Global Dim history.history(40)
  ;
  ; action state values
  ;
  #wait = 1
  #fail = 2
  #pass = 3
  #skip = 4
  #error = 5
  ;
  ; x_lib related
  ;
  x_ping_timeout = 400                                     ; 50 msec should be enough for normal (local) networks but 100 seems to be more stable
  ;
  ; *** onboard help
  ;
  DataSection
    ;
    quickhelp_text:
    IncludeBinary("wakiewakie.txt")
    Data.l 0
    ;
  EndDataSection
  Global p_quickhelp_text.i = ?quickhelp_text
  ;
EndProcedure

Procedure main()
  Protected n.i, ip.i, i.s, l.i, t.s, m.s, p.i, nn.i,s.s
  Protected action.i, timer_check.i
  Protected x.i, y.i, h.i, action_state.i
  Protected ping.x_threadping_status, thread_nr.i, command.s, progress.i, adapter_state.i, progress_state.i
  Protected target.s, link.s
  Protected old_router_ip.s, old_server_ip.s
  ;
  ; *** command line processing
  ;
  ; grab command line, if none perhaps create one (for debugging purposes)
  ;
  Repeat
    command = ProgramParameter()
    commandline = commandline+" "+command
  Until command = ""
  commandline = Trim(commandline)
  If commandline = "" And #codecaddy_compilerun = #True
    ; commandline = "history adapter 192.168.*.* router 192.168.0.99 server 192.168.0.150 mac BC:5F:F4:12:06:9E black"
    ; commandline = "adapter 192.168.*.* router 192.168.0.91 server 192.168.0.99 mac AB:05:00:12:12:13 slow"
    ; commandline = "adapter 192.168.*.* router 192.168.0.91"
    ; commandline = "adapter 192.168.*.* router 192.168.0.91 server 192.168.0.99 mac AB:05:00:12:12:13 slow gui"
    ; commandline = "help"
    ; commandline = "history adapter 192.168.0.* router 192.168.0.99 server 192.168.0.5 mac E8:DE:27:03:E7:38 retry 400"
    ; commandline = "history adapter 192.168.*.* router 192.168.0.99 server 192.168.0.4 mac E8:DE:27:03:E7:38 retry 400"
    ; commandline = "history adapter 192.168.*.* router 192.168.0.99 server 192.168.0.21 mac 00:19:99:08:FC:E0 retry 400"
    ; commandline = "history clear adapter 192.168.*.* router 192.168.0.99 server 192.168.0.21 mac 00:19:99:08:FC:E0 retry 400 linger 10"
    ; commandline = "history adapter 192.168.*.* router 192.168.0.99 server 192.168.0.23 mac 00:19:99:08:FC:E0 retry 400 linger 59900"
    ; commandline = "history adapter 192.168.*.* router 192.168.0.99 server 192.168.0.23 mac 00:19:99:08:FC:E0 black border 0"
    ; commandline = "history adapter 192.168.*.* router 192.168.0.99 server 192.168.0.23 mac 00:19:99:08:FC:E0 color $FFFFFF $0000FF"
    ; commandline = "adapter 192.168.*.* router 192.168.0.99 server 192.168.0.22 mac 00:1A:A0:C8:EF:4F retry 400 linger 400 black border 0"
    ; commandline = "history adapter 192.168.*.* router 192.168.0.99 server 192.168.0.23 mac 00:1A:A0:C8:EF:4F retry 400 linger 400 black border 2"
    ; commandline = "history adapter 192.168.*.* router 192.168.0.99 server 192.168.0.6 mac D0:50:99:48:E1:9D color $FFFFFF $000080 linger 1100"
    ; commandline = "history adapter 192.168.*.* router 192.168.0.99 server 255.255.255.255 mac D0:50:99:48:E1:9D color $FFFFFF $000080 linger 1100 all"
    commandline = "history adapter 192.168.*.* router 192.168.0.99 server 192.168.0.6 mac D0:50:99:48:E1:9D color $FFFFFF $000080 linger 1100 all"
    ; commandline = "gui"
  EndIf
  If commandline = ""
    If x_registry_get(#HKEY_CURRENT_USER,"Software\Microsoft\Windows\CurrentVersion\Run","Wakiewakie") = 0
      p = FindString(x_registry_s,Chr(34),2)
      commandline = Trim(Mid(x_registry_s,p+1))+" gui"
    EndIf
  EndIf
  ;
  commandline = Trim(ReplaceString(commandline,Chr(39),Chr(34)))
  n = x_commandcount(commandline)
  If n = 0
    gui = #True
  Else
    nn = 0
    While nn < n
      nn = nn+1
      command = x_commandfield(commandline,nn)
      Select LCase(command)
          Case "gui"
            gui = #True
          Case "slow"
            slow = #True
          Case "retry"
            nn = nn+1
            retry_time = Val(x_commandfield(commandline,nn))
          Case "history"
            history = #True
          Case "clear"
            history_clear = #True
          Case "linger"
            nn = nn+1
            linger_time = Val(x_commandfield(commandline,nn))
          Case "border", "window"
            nn = nn+1
            border = Val(x_commandfield(commandline,nn))
          Case "color"
            nn = nn+1
            color_front = Val(x_commandfield(commandline,nn))
            nn = nn+1
            color_back = Val(x_commandfield(commandline,nn))
          Case "black"
            color_front = $FFFFFF
            color_back = $000000
          Case "adapter", "adapter_ip"
            nn = nn+1
            adapter_ip = x_commandfield(commandline,nn)
          Case "router", "router_ip"
            nn = nn+1
            router_ip = x_commandfield(commandline,nn)
          Case "server", "server_ip"
            nn = nn+1
            server_ip = x_commandfield(commandline,nn)
          Case "mac", "server_mac"
            nn = nn+1
            server_mac = x_commandfield(commandline,nn)
          Case "all"
            all = #True
          Case "help", "?", "/?"
            x_littlehelp(" Wakiewakie "+#ww_version+" - "+#ww_copyright,"",p_quickhelp_text,#PB_Ascii)
            gui = #True
          Default
            MessageRequester("Wakiewakie "+#ww_version+" - "+#ww_copyright,"Unknown parameter: "+command,#PB_MessageRequester_Ok)
      EndSelect
    Wend
  EndIf
  ;
  ; make sure all parameters are within bounds
  ;
  x_ping_timeout = x_max(50,x_ping_timeout)
  retry_time = x_max(3*x_ping_timeout,retry_time)
  retry_time = x_max(300,retry_time)
  server_mac = ReplaceString(server_mac,"-",":")
  server_mac = ReplaceString(server_mac,";",":")
  server_mac = ReplaceString(server_mac,".",":")
  server_mac = ReplaceString(server_mac,",",":")
  server_mAC = UCase(server_mac)
  commandline = ""
  If gui = #True
    slow = #True
  EndIf
  ;
  adapter_state = #fail
  ;
  ; retrieve historic data
  ;
  history_filename = GetPathPart(ProgramFilename())+"wakiewakie.his"
  If history And Not history_clear
    If x_exist(history_filename)
      ReadFile(1,history_filename)
      n = 0
      While Not Eof(1)
        s = ReadString(1)
        If Trim(StringField(s,3,",")) = server_ip
          server_name_resolved = Trim(StringField(s,2,","))    ; it actually isn't resolved but this keeps a name in the history file even when the system was 'hot'
          attempts = Val(StringField(s,5,","))
          warm = Val(StringField(s,6,","))
          average = Val(StringField(s,7,","))
          cold = Val(StringField(s,8,","))
        Else
          n = n+1
          With history(n)
            \timestamp = Trim(StringField(s,1,","))
            \name = Trim(StringField(s,2,","))
            \ip = Trim(StringField(s,3,","))
            \mac = Trim(StringField(s,4,","))
            \attempts = Val(StringField(s,5,","))
            \warm = Val(StringField(s,6,","))
            \average = Val(StringField(s,7,","))
            \cold = Val(StringField(s,8,","))
            \state = Trim(StringField(s,9," , "))
            If Right(\state,1)= "*"
              \state = x_chop(\state,0,2)
            EndIf
          EndWith
        EndIf
      Wend
      CloseFile(1)
      history_n = n
    EndIf
  EndIf
  ;
  timestamp = x_formatdate(Date(),"/")
  starttime = x_timer()
  ;
  ; *** create main window
  ;
  h = 250
  If gui
    h = h+155
  EndIf
  Select border
      Case 0
        n = #PB_Window_ScreenCentered|#PB_Window_Invisible
      Case 1
        n = #PB_Window_ScreenCentered|#PB_Window_BorderLess
      Case 2
        n = #PB_Window_ScreenCentered|#PB_Window_Tool
      Default
        n = #PB_Window_ScreenCentered|#PB_Window_Normal|#PB_Window_SystemMenu
  EndSelect
  w_main_h = OpenWindow(#w_main_nr,10,10,510,h,"Wakiewakie - "+#ww_version+" - "+#ww_copyright,n)
  AddKeyboardShortcut(#w_main_nr,#PB_Shortcut_Escape,1)
  ;
  x = 10
  y = 12
  h = 60
  ImageGadget(#g_adapter_led,x,y,16,16,ImageID(#i_led_white))
  TextGadget(#g_adapter_t,x+20,y+2,100,16,"Adapter (local IP)")
  If gui
    StringGadget(#g_adapter_ip,x+140,y,100,18,adapter_ip)
    GadgetToolTip(#g_adapter_ip,"Local adapter address or pattern, for example 192.168.*.*, leave empty if not needed")
  Else
    TextGadget(#g_adapter_ip,x+140,y+2,100,18,adapter_ip)
  EndIf
  TextGadget(#g_adapter_note,x+265,y,225,h,"")
  y = y+20+h
  h = 40
  ImageGadget(#g_router_led,x,y,16,16,ImageID(#i_led_white))
  TextGadget(#g_router_t,x+20,y+2,100,16,"Router IP address")
  If gui
    StringGadget(#g_router_ip,x+140,y,100,18,router_ip)
    GadgetToolTip(#g_router_ip,"Some always-on device to ping, typically a router, leave empty if not needed")
  Else
    TextGadget(#g_router_ip,x+140,y+2,100,18,router_ip)
  EndIf
  TextGadget(#g_router_note,x+265,y,225-18,h,"")
  y = y+20+h
  h = 40
  ImageGadget(#g_server_ip_led,x,y,16,16,ImageID(#i_led_white))
  TextGadget(#g_server_ip_t,x+20,y+2,100,16,"Server IP address")
  TextGadget(#g_server_note,x+265,y,225,h,"")
  TextGadget(#g_server_mac_t,x+20,y+2+20,100,16,"MAC address")
  If gui
    StringGadget(#g_server_ip,x+140,y,100,18,server_ip)
    GadgetToolTip(#g_server_ip,"IP address of device to wake up, used to test if WOL succeeded.")
    ; ButtonGadget(#g_server_ip_take,x+119,y+19,18,20,">")
    StringGadget(#g_server_mac,x+140,y+20,100,18,UCase(server_mac))
    ButtonGadget(#g_server_ip_take,x+241,y+19,18,20,"<")
    GadgetToolTip(#g_server_mac,"MAC address of device to wake up, for example 01:23:45:67:89:AB, use the < button to copy the discovered mac address")
  Else
    TextGadget(#g_server_ip,x+140,y+2,100,18,server_ip)
    TextGadget(#g_server_mac,x+140,y+22,100,16,UCase(server_mac))
  EndIf
  y = y+20+h
  h = 30
  If gui
    TextGadget(#g_retry_t,x+20,y+2,100,16,"Retry time (msec)")
    StringGadget(#g_retry_time,x+140,y,100,18,Str(retry_time))
    GadgetToolTip(#g_retry_time,"Retry time in msec")
    TextGadget(#g_retry_note,x+265,y,225,h,"If a check fails retry / delay will be used. Always applies when using GUI. Minimal 300.")
  Else
    ProgressBarGadget(#g_progress_bar,x+20,y,450,18,0,1000,#PB_ProgressBar_Smooth)
    If history
      ImageGadget(#g_progress_led,x,y,16,16,ImageID(#i_led_white))
    EndIf
  EndIf
  If gui
    y = y+20+h
    TextGadget(#g_commandline_other_t,x+20,y,100,16,"Other (see help)")
    StringGadget(#g_commandline_other,x+140,y,350,18,commandline_other)
    y = y+10+h
    h = 3*16
    TextGadget(#g_commandline_t,x+20,y,100,16,"Command line")
    TextGadget(#g_commandline,x+140,y,350,h,commandline)
    ;
    y = y+h+10
    x = 270
    ImageGadget(#g_autorun_led,x,y+9,16,16,ImageID(#i_led_green))
    x = 295
    ButtonImageGadget(#g_autorun_set,x,y,32,32,ImageID(#i_windows))
    GadgetToolTip(#g_autorun_set,"Create autorun entry in the registry, requires valid command line")
    x = x+35
    ButtonImageGadget(#g_autorun_clear,x,y,32,32,ImageID(#i_windows_grey))
    GadgetToolTip(#g_autorun_clear,"Remove autorun entry from the registry")
    x = x+35
    ButtonImageGadget(#g_shortcut,x,y,32,32,ImageID(#i_shortcut))
    GadgetToolTip(#g_shortcut,"Create shortcut, requires server IP to be set")
    x = x+35
    ButtonImageGadget(#g_copy,x,y,32,32,ImageID(#i_copy))
    GadgetToolTip(#g_copy,"Copy commandline to clipboard")
    x = x+35
    ButtonImageGadget(#g_help,x,y,32,32,ImageID(#i_help))
    x = x+35
    ButtonImageGadget(#g_exit,x,y,32,32,ImageID(#i_exit))
    ;
    If x_registry_get(#HKEY_CURRENT_USER,"Software\Microsoft\Windows\CurrentVersion\Run","Wakiewakie") = 0
      HideGadget(#g_autorun_led,0)
    Else
      HideGadget(#g_autorun_led,1)
    EndIf
    ;
  EndIf
  ;
  ; *** paint it black!
  ;
  If Not gui And color_front <> -1 And color_back <> -1
    SetWindowColor(#w_main_nr,color_back)
    For n = #g_adapter_led To #g_shortcut
      If IsGadget(n)
        SetGadgetColor(n,#PB_Gadget_BackColor,color_back)
        SetGadgetColor(n,#PB_Gadget_FrontColor,color_front)
      EndIf
    Next n
  EndIf
  ;
  ; *** event loop
  ;
  action = #f_check_adapter                                ; regardless if in GUI or not, always start by checking adapters
  ;
  Repeat
    ;
    ; first part of the endless loop... take some action
    ;
    ; there are 4 stages
    ;
    ; stage 1 - check adapter address
    ; stage 2 - ping router
    ; stage 3 - send wol
    ; stage 4 - ping server
    ;
    ; there are 3 steps for each stage
    ;
    ; step 1 - prepare, send out a ping, a wol, etc. (before the inner loop)
    ; step 2 - check the results of the previous step, update screen upon 'pass' (inside the inner loop)
    ; step 3 - any timeout means a fail, update screen when 'failed' (after the inner loop)
    ;
    ; v1.20x the progress bar is now updated in a seperate thread
    ;
    If gui
      ;
      ; running a gui, so show a possible command line
      ;
      t = ""
      If Len(adapter_ip) >= 2 And CountString(adapter_ip,".") >0
        t = t+" adapter "+adapter_ip
        If Right(adapter_ip,1) = "."
          t = t+"*"
        EndIf
      EndIf
      If x_checkipaddress(router_ip)
        t = t+" router "+router_ip
      EndIf
      If x_checkipaddress(server_ip)
        t = t+" server "+server_ip
      EndIf
      If Len(server_mac) >= 17
        t = t+" mac "+server_mac
      EndIf
      If retry_time <> #retry_time
        t = t+" retry "+Str(retry_time)
      EndIf
      If linger_time <> #linger_time
        t = t+" linger "+Str(linger_time)
      EndIf
      t = Trim(t)+" "+Trim(commandline_other)
      If t <> commandline
        commandline = t
        SetGadgetText(#g_commandline,"wakiewakie.exe "+commandline)
      EndIf
    EndIf
    ;
    Select action
        Case #f_check_adapter
          ;
          ; stage 1 step 1 - make sure we have been assigned a valid ip address
          ;
          action_state = #fail                                         ; there's actually no such thing as 'wait' when checking adapter
          t = ""
          n = 0
          s = ReplaceString(adapter_ip,".*",".")
          s = ReplaceString(s.s,"..",".")
          s = ReplaceString(s.s,"..",".")
          l = Len(s)
          ExamineIPAddresses()
          Repeat
            ip = NextIPAddress()
            If ip <> 0                                                 ; next valid adapter
              n = n+1
              i = IPString(ip)
              m = x_getmacaddress(i)
              t = t+#CRLF$+Str(n)+" - "+i+" - "+m
              If l > 0 And Left(i,l) = s
                action_state = #pass
              EndIf
            EndIf
          Until ip = 0 Or n = 20
          t = Hostname()+" "+x_getipaddress(Hostname())+" "+Str(n)+" adapter(s)"+t
          If t <> adapter_note
            adapter_note = t
            SetGadgetText(#g_adapter_note,t)
          EndIf
          If Len(adapter_ip) >= 2 And CountString(adapter_ip,".") >0
            If action_state = #pass
              SetGadgetState(#g_adapter_led,ImageID(#i_led_green))
            Else
              SetGadgetState(#g_adapter_led,ImageID(#i_led_red))
            EndIf
          ElseIf adapter_ip = ""
            action_state = #skip
            SetGadgetState(#g_adapter_led,ImageID(#i_led_white))
          Else
            SetGadgetState(#g_adapter_led,ImageID(#i_led_yellow))
            action_state = #skip
          EndIf
          ;
        Case #f_ping_router
          ;
          ; stage 2 step 1 - check if the router can be reached
          ;
          If IsThread(thread_nr)
            action_state = #fail
          ElseIf x_checkipaddress(router_ip)
            ping\bip = MakeIPAddress(Val(StringField(router_ip,1,".")),Val(StringField(router_ip,2,".")),Val(StringField(router_ip,3,".")),Val(StringField(router_ip,4,".")))
            ping\status = 0
            thread_nr = CreateThread(@x_threadping(),@ping)
            action_state = #wait
          ElseIf router_ip = ""
            action_state = #skip
            SetGadgetState(#g_router_led,ImageID(#i_led_white))
          Else
            SetGadgetState(#g_router_led,ImageID(#i_led_yellow))
            action_state = #skip
          EndIf
          ;
        Case #f_wakeup_server
          ;
          ; stage 3 step 1 - router can be reached, try to wake up the server
          ;
          If Len(server_mac) >= 17
            x_wakeonlan(server_mac)
            action_state = #pass
          Else
            action_state = #skip
          EndIf
          ;
        Case #f_ping_server
          ;
          ; stage 4 step 1 - check if the router can be reached
          ;
          If IsThread(thread_nr)
            action_state = #fail
          ElseIf x_checkipaddress(server_ip)
            ping\bip = MakeIPAddress(Val(StringField(server_ip,1,".")),Val(StringField(server_ip,2,".")),Val(StringField(server_ip,3,".")),Val(StringField(server_ip,4,".")))
            ping\status = 0
            thread_nr = CreateThread(@x_threadping(),@ping)
            action_state = #wait
          ElseIf server_ip = ""
            action_state = #skip
            SetGadgetState(#g_server_ip_led,ImageID(#i_led_white))
          Else
            SetGadgetState(#g_server_ip_led,ImageID(#i_led_yellow))
            action_state = #skip
          EndIf
          ;
    EndSelect
    ;
    ; second part of the endless loop - check results and handle windows events
    ;
    timer_check = x_timer()+retry_time
    ;
    Repeat
      ;
      If action_state = #wait                                              ; ie. we haven't concluded yet if it was a pass or fail
        Select action
            Case #f_check_adapter
              ;
              ; stage 1 step 2 - adapter state
              ;
              action_state = #error
              Debug "error 12"
              ;
            Case #f_ping_router
              ;
              ; stage 2 step 2 - can router be reached?
              ;
              If ping\status > 0
                SetGadgetState(#g_router_led,ImageID(#i_led_green))
                If router_ip <> old_router_ip
                  If gui = #True Or slow = #True
                    router_mac_resolved = x_getmacaddress(router_ip)
                    router_name_resolved = x_ws_iptoname(router_ip)
                    If Trim(router_name_resolved) = ""
                      router_name_resolved = "unresolved"
                    EndIf
                    old_router_ip = router_ip
                    t = router_name_resolved+" "+router_ip+" ping "+Str(ping\status)+#CRLF$+"1 - "+router_ip+" - "+router_mac_resolved
                  Else
                    t = "ping "+Str(ping\status)
                  EndIf
                  SetGadgetText(#g_router_note,t)
                EndIf
                action_state = #pass
              EndIf
              ;
            Case #f_wakeup_server
              ;
              ; stage 3 step 2 - router can be reached, try to wake up the server
              ;
              action_state = #error
              Debug "error 32"
              ;
            Case #f_ping_server
              ;
              ; stage 4 step 2 - can server be reached?
              ;
              If ping\status > 0
                SetGadgetState(#g_server_ip_led,ImageID(#i_led_green))
                If old_server_ip <> server_ip
                  If gui = #True Or slow = #True
                    server_mac_resolved = x_getmacaddress(server_ip)
                    server_name_resolved = x_ws_iptoname(server_ip)
                    If Trim(server_name_resolved) = ""
                      server_name_resolved = "unresolved"
                    EndIf
                    old_server_ip = server_ip
                    t = server_name_resolved+" "+server_ip+" ping "+Str(ping\status)+#CRLF$+"1 - "+server_ip+" - "+server_mac_resolved
                  Else
                    t = "ping "+Str(ping\status)
                  EndIf
                  SetGadgetText(#g_server_note,t)
                EndIf
                action_state = #pass
              EndIf
              ;
            Default
              Debug "error 66"
              ;
        EndSelect
      EndIf
      ;
      If history
        event = WaitWindowEvent(retry_time/8)                                           ; v1.20x eperimental: smooth the progress bar
      Else
        event = WaitWindowEvent(retry_time/4)
      EndIf
      event_window = EventWindow()
      event_menu = EventMenu()
      event_type = EventType()
      event_gadget = EventGadget()
      ;
      If Not gui                                                                         ; v1.20x moved updating progress bar to inside tight loop for smoother updates
        ;
        ; not running a gui, so update the progress bar
        ;
        If history And warm > 0 And cold > 0
          ;
          ; run with history, try to do smart things with the progress bar
          ;
          x = x_timer()-starttime
          If x < warm*1.3
            If progress_state = 0
              progress_state = 1
              SetGadgetState(#g_progress_led,ImageID(#i_led_green))
            EndIf
            progress = x_min(1000,(x_timer()-starttime)*920/warm)
          ElseIf x < cold*1.3
            If progress_state = 1
              progress_state = 2
              SetGadgetState(#g_progress_led,ImageID(#i_led_yellow))
            EndIf
            progress = x_min(1000,(x_timer()-starttime)*920/cold)
          ElseIf x < 180000
            If progress_state = 2
              progress_state = 3
              SetGadgetState(#g_progress_led,ImageID(#i_led_red))
            EndIf
            progress = x_min(1000,(x_timer()-starttime)/180)
          Else
            If progress_state = 3
              progress_state = 4
              SetGadgetState(#g_progress_led,ImageID(#i_led_cyan))
            EndIf
            progress = 1000
          EndIf
          ;
        Else
          ;
          ; run without history, progress bar is updated by stage / action
          ;
          progress = x_max(progress,action*200)
          ;
        EndIf
        SetGadgetState(#g_progress_bar,progress)
      EndIf
      ;
      ; windows event handling
      ;
      Select event
          Case #PB_Event_Menu
            action = #f_exit
          Case #PB_Event_CloseWindow
            action= #f_exit
          Case #PB_Event_Gadget
            Select event_gadget
                Case #g_server_ip_take
                  ;
                  ; use mac address belonging to server ip address
                  ;
                  server_mac = server_mac_resolved
                  SetGadgetText(#g_server_mac,server_mac)
                  ;
                Case #g_help
                  ;
                  ; show help window
                  ;
                  HideWindow(#w_main_nr,#True)
                  x_littlehelp(" Wakiewakie "+#ww_version+" - "+#ww_copyright,"",p_quickhelp_text,#PB_Ascii)
                  HideWindow(#w_main_nr,#False)
                  ;
                Case #g_copy
                  ;
                  ; copy commandline to clipboard
                  ;
                  SetClipboardText("wakiewakie.exe "+commandline)
                  ;
                Case #g_exit
                  ;
                  ; exit the program
                  ;
                  action = #f_exit
                  ;
                Case #g_shortcut
                  ;
                  ; create a shortcut on the desktop
                  ;
                  If x_checkipaddress(server_ip)
                    target.s = ProgramFilename()
                    link.s = x_getspecialfolderlocation(#CSIDL_DESKTOPDIRECTORY) + "wakiewakie "+server_ip+".lnk"
                    x_createshelllink(target, link, commandline, "", GetPathPart(target), target, 0)
                  EndIf
                  ;
                Case #g_autorun_set
                  ;
                  ; add autorun to the registry
                  ;
                  If commandline > ""
                    t = Chr(34)+ProgramFilename()+Chr(34)+" "+commandline
                    x_registry_set(#HKEY_CURRENT_USER,"Software\Microsoft\Windows\CurrentVersion\Run","Wakiewakie",#REG_SZ,0,t,1)
                    HideGadget(#g_autorun_led,0)
                  EndIf
                  ;
                Case #g_autorun_clear
                  ;
                  ; remove autorun to the registry
                  ;
                  x_registry_delete(#HKEY_CURRENT_USER,"Software\Microsoft\Windows\CurrentVersion\Run","Wakiewakie")
                  HideGadget(#g_autorun_led,1)
                  ;
                Case #g_adapter_ip, #g_router_ip, #g_server_ip, #g_server_mac, #g_retry_time, #g_commandline_other
                  ;
                  ; something happened to one of the modifyable string gadgets
                  ;
                  adapter_ip = GetGadgetText(#g_adapter_ip)
                  router_ip = GetGadgetText(#g_router_ip)
                  server_mac = GetGadgetText(#g_server_mac)
                  server_ip = GetGadgetText(#g_server_ip)
                  retry_time = Val(GetGadgetText(#g_retry_time))
                  retry_time = x_max(4*x_ping_timeout,retry_time)
                  retry_time = x_max(300,retry_time)
                  commandline_other = GetGadgetText(#g_commandline_other)
                  ;
            EndSelect
      EndSelect
      ;
    Until (action = #f_exit) Or (x_timer() > timer_check) Or (action_state = #pass And slow = #False) Or (action_state = #skip)
    ;
    ; if action_state is still wait then we hit a timeout and the action failed
    ; update whenever required
    ;
    If action_state = #wait
      Select action
          Case #f_check_adapter
            ;
            ; stage 1 step 3
            ;
            action_state = #error
            Debug "error 13"
            ;
          Case #f_ping_router
            ;
            ; stage 2 step 3
            ;
            SetGadgetState(#g_router_led,ImageID(#i_led_red))
            SetGadgetText(#g_router_note,"")
            action_state = #fail
            old_router_ip = ""
            ;
          Case #f_wakeup_server
            ;
            ; stage 3 step 4
            ;
            action_state = #error
            Debug "error 34"
            ;
          Case #f_ping_server
            ;
            ; stage 4 step 3
            ;
            SetGadgetState(#g_server_ip_led,ImageID(#i_led_red))
            SetGadgetText(#g_server_note,"")
            action_state = #fail
            old_server_ip = ""
            ;
      EndSelect
    EndIf
    ;
    ;
    If action > #f_exit
      Debug "error 55"
    ElseIf action = #f_exit
    ElseIf action = #f_ping_server
      If gui = #True Or action_state = #fail
        action = #f_check_adapter
        slow = #True
      Else
        ;
        ; 1.43 ugly hack to support 'all' parameter, adapter ip and router ping must pass
        ; 
        If all = #True And (GetGadgetState(#g_adapter_led) = ImageID(#i_led_red) Or GetGadgetState(#g_router_led) = ImageID(#i_led_red))
        Else
          action = #f_done
        EndIf
        ;
      EndIf
    Else
      action = action+1
    EndIf
    ;
  Until action = #f_exit Or action = #f_done
  ;
  ; if everything was ok this will allow windows to update the leds
  ;
  If action_state = #pass And Not gui
    SetGadgetState(#g_progress_bar,1000)
    If action = #f_done And history
      SetGadgetState(#g_progress_led,ImageID(#i_led_green))
    EndIf
  EndIf
  If IsThread(thread_nr) Or Not gui
    timer_check = x_timer()+x_ping_timeout
    Repeat
      WaitWindowEvent(x_ping_timeout/4)
    Until x_timer() > timer_check
  EndIf
  ;
  ; store history
  ;
  If history And action = #f_done
    ;
    ; calculate new numbers
    ;
    attempts = attempts+1
    x = x_timer()-starttime
    n = x_min(10,attempts)
    If x < 2*1000                                     ; a reply within two seconds most likely means its already up and running
      t = "hot"
    ElseIf x < warm*0.95                              ; definitely a warm boot
      warm = (warm*n+4*x)/(n+4)
      average = (average*n+x)/(n+1)
      t = "warm warm"
    ElseIf x < (warm+cold+average)/3                  ; most likely a warm boot
      warm = (warm*n+x)/(n+1)
      cold = (cold*n*2+x)/(n*2+1)
      average = (average*n+x)/(n+1)
      t = "warm"
    ElseIf x < cold*1.05                              ; most likely a cold boot
      warm = (warm*n*2+x)/(n*2+1)
      cold = (cold*n+x)/(n+1)
      average = (average*n+x)/(n+1)
      t = "cold"
    ElseIf x < 180*1000                               ; definitely a cold boot
      cold = (cold*n+4*x)/(n+4)
      average = (average*n+x)/(n+1)
      t = "cold cold"
    Else                                              ; no reply within three minutes is likely a fail
      t = "fail"
    EndIf
    warm = x_min(warm,average)
    cold = x_max(cold,average)
    ;
    ; add new entry to the bottom of the array
    ;
    history_n = history_n+1
    With history(history_n)
      \timestamp = timestamp
      \name = server_name_resolved
      \ip = server_ip
      \mac = server_mac
      \attempts = attempts
      \warm = warm
      \average = average
      \cold = cold
      \state = Str(x)+" "+t+" *"
    EndWith
    ;
    ; resort the array
    ;
    If history_n > 0
      SortStructuredArray(history(),#PB_Sort_Ascending,OffsetOf(history\ip),TypeOf(history\ip),1, history_n)
    EndIf
    ;
    ; store history data
    ;
    CreateFile(1,history_filename)
    n = 0
    With history(n)
      While n < history_n
        n = n+1
        WriteString(1,\timestamp+" , "+\name+" , "+\ip+" , "+\mac+" , "+Str(\attempts)+" , "+Str(\warm)+" , "+Str(\average)+" , "+Str(\cold)+" , "+\state+#CRLF$)
      Wend
    EndWith
    ;
    CloseFile(1)
  EndIf
  ;
  ; lingering
  ;
  If t = "fail"
    ;
    ; fail, show the window indefinitely
    ;
    Repeat
      event = WaitWindowEvent(1000)
    Until event = #PB_Event_CloseWindow
    ;
  ElseIf linger_time < 0 And t = "hot"
    ;
    ; hot boot on non-adaptive lingering, skip linger
    ;
  ElseIf linger_time <> 0 And action <> #f_exit
    ;
    ; didn't fail, adjust linger time depending on the type of start
    ;
    If linger_time > 0
      Select t
          Case "hot"
            linger_time = linger_time*1
          Case "warm warm"
            linger_time = linger_time*1.4+500
          Case "warm"
            linger_time = linger_time*1.4*1.3+1000+x/20
          Case "cold"
            linger_time = linger_time*1.4*1.3*1.2+1500+x/10
          Case "cold cold"
            linger_time = linger_time*1.4*1.3*1.2*1.1+2000+x/5
      EndSelect
      linger_time = x_min(Abs(linger_time),3*60*1000)
    EndIf
    ;
    ; repeat until window is closed or lingering is done
    ;
    timer_check = x_timer()
    Repeat
      event = WaitWindowEvent(50)
      If linger_time > 1000
        n = x_limit(1000*(x_timer()-timer_check)/linger_time,0,1000)
        SetGadgetState(#g_progress_bar,n)
      EndIf
    Until event = #PB_Event_CloseWindow Or x_timer() > timer_check+linger_time
  EndIf
  ;
EndProcedure

; IDE Options = PureBasic 5.62 (Windows - x86)
; CursorPosition = 24
; Folding = -
; Markers = 373,1031,1043
; EnableThread
; EnableXP
; UseIcon = icons\wifi_onoff.ico
; Executable = wakiewakie.exe
; CompileSourceDirectory
; EnableUnicode